//
//  PersonCenterViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class PersonCenterViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {

    @IBOutlet weak var shopNameLbl: UILabel!
    @IBOutlet weak var iconImg: UIImageView!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var topBgImg: UIImageView!
    @IBOutlet weak var topImgBg: UIImageView!
    @IBOutlet weak var listView: UITableView!
    var dataModel : AdminInfoModel? = nil
    let listArray = ["格利支付","蓝牙打印设置","权限设置"]
    //MARK:--加载数据
    func loadData(){
        let UserToken = UserDefaults.standard.value(forKey: "user_token")

        adminInfo(["user_token":UserToken as Any], success: { (data) in
            self.dataModel = (data as! AdminInfoModel)
            self.iconImg.kf.setImage(with: URL(string: SERVERCE_HOST + (self.dataModel?.data?.shop_img)!))
            self.shopNameLbl.text = self.dataModel?.data?.stall_name
            self.nameLbl.text = self.dataModel?.data?.admin_name
        }) { (error) in
            
        }
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        if dataModel == nil {
            loadData()
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        topImgBg.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(0)
            make.height.equalTo(227*glscale)
        }
        topBgImg.snp.makeConstraints { (make) in
            make.bottom.equalTo(topImgBg.snp_top)
            make.left.right.equalTo(0)
            make.height.equalTo(60)
        }
        
        listView.delegate = self
        listView.dataSource = self
        listView.isScrollEnabled = false
        listView.separatorStyle = .none
        listView?.register(UINib(nibName: "PersonCenterCell", bundle: nil), forCellReuseIdentifier: "listCell")
        // Do any additional setup after loading the view.
        
        /*
        自适应字体大小后重新编辑背景框
        shopNameLbl.text = "123"
        shopNameLbl.sizeToFit()
        shopNameLbl.snp.makeConstraints { (make) in
            make.left.equalTo(nameLbl.snp_left)
            make.top.equalTo(nameLbl.snp_bottom).offset(10)
            make.width.equalTo(shopNameLbl.frame.size.width+8)
            make.height.equalTo(20)
        }
        */
    }
    //MARK: -方法
    @IBAction func editAction(_ sender: Any) {
        print("编辑资料")
        if self.dataModel == nil {
            return
        }
        let vc = AccountViewController()
        vc.dataModel = self.dataModel
        self.navigationController?.pushViewController(vc, animated: true)

    }
    //MARK:--跳转消息中心
    @IBAction func toMsgCenterAction(_ sender: Any) {
        print("跳转消息中心")
        let vc = MsgCenterViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }

     //MARK: -Cell delegate方法
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath.row)
        if indexPath.row == 0 {
            //格利支付
            let vc = PayViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }else if indexPath.row == 1 {
            //蓝牙设置
            let vc = BluetoothConnectViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }else if indexPath.row == 2{
            //权限设置-弹窗
            let vc = WebViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
       func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
           return 50*glscale
       }
       func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return listArray.count
       }
       
       func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        var cell = tableView.dequeueReusableCell(withIdentifier: "listCell") as! PersonCenterCell
        cell.titleLbl.text = listArray[indexPath.row]
        return cell
       }

}
