//
//  WarehoseMangementListVC.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/25.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator

class WarehoseMangementListVC: BaseViewController, UISearchBarDelegate, UITableViewDelegate, UITableViewDataSource, SearchBarViewDelegate {
    weak var searchV: SearchBarView? = nil
    @IBOutlet weak var contentView: UIView!
    @IBOutlet weak var searchView: UIView!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = UIColor.white
        //searchbar
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.searchView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchBr.delegateL = self
        searchBr.placeholderStr = "请输入仓库名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        setTabv()
    }
 
    //MARK:--搜索按钮代理
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        
        tableSearchV = UITableView()
        contentView.addSubview(tableSearchV);
        tableSearchV.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        tableSearchV.delegate = self
        tableSearchV.dataSource = self
        tableSearchV.separatorStyle = .none
        tableSearchV?.register(UINib(nibName: "WarehoseMangementCell", bundle: nil), forCellReuseIdentifier: "WarehoseMangementCell")
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
        }
    }
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        contentView.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.top.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    //MARK:--清除搜索代理
    func clearSearchAction() {
        if tableSearchV != nil {
            tableSearchV.removeFromSuperview()
        }
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
    }
    //MARK:--新增代理
    @IBAction func addNewWarehose(_ sender: UIButton) {
        print("点击新增--")
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
        let vc = CheckWareHourseViewController()
        self.navigationController?.pushViewController(vc, animated: false)
    }
    
    var tableV :UITableView!
    var tableSearchV :UITableView! = nil

    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]

    func setTabv() {
        tableV = UITableView()
        contentView.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "WarehoseMangementCell", bundle: nil), forCellReuseIdentifier: "WarehoseMangementCell")
        tableV.performBatchUpdates({
            UIView.animate(views: self.tableV!.visibleCells,
                           animations: self.animations, completion: {
                            
            })
        }, completion: nil)
        
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == tableSearchV {
            return 3
        }
        return 10
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "WarehoseMangementCell") as! WarehoseMangementCell
        
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath)
        let vc = CheckWareHourseViewController()
        self.navigationController?.pushViewController(vc, animated: false)
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 94*glscale
    }
}
