//
//  JiTuoWuXinXiView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class JiTuoWuXinXiView: UIView {
    var contentView:UIView!
    @IBOutlet weak var infoSw: UISwitch!
    @IBOutlet weak var bottomView: UIView!
    
    func setUI(){
        infoSw.transform = CGAffineTransform(scaleX: 0.8, y: 0.8)
        let maskPath = UIBezierPath(roundedRect: bottomView.bounds,
        byRoundingCorners:[.topLeft, .topRight], cornerRadii:CGSize(width:3, height:3))
        let masklayer = CAShapeLayer()
        masklayer.frame = bottomView.bounds
        masklayer.path = maskPath.cgPath
        bottomView.layer.mask = masklayer
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        self.setUI()
        return view
    }

}
