//
//  XiaYunDanViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class XiaYunDanViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    var jtwxxView:JiTuoWuXinXiView?
    var selectBtn:UIButton?
    let titleArr = ["物品寄托","寄派方式","增值服务","温控范围"]
    let title2Arr = ["关联订单号","关联平台"]
    @IBOutlet weak var priceLbl: UILabel!
    @IBAction func orderAction(_ sender: Any) {
    }
    @IBOutlet weak var bottomView: UIView!
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomView.snp_top)
        }
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "AdressSelectCell", bundle: nil), forCellReuseIdentifier: "AdressSelect")
        listView.register(UINib(nibName: "PersonCenterCell", bundle: nil), forCellReuseIdentifier: "PersonCenter")
        listView.register(UINib(nibName: "TitleAndOnlyBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndOnlyBtn")
        listView.register(UINib(nibName: "WenDuCell", bundle: nil), forCellReuseIdentifier: "WenDu")
        // Do any additional setup after loading the view.
    }
    
    @objc func selectBtnClick(sender:UIButton){
        if sender.tag == 99 {
            //跳转查看合同页面
            print("跳转查看合同页面")
            return
        }
        selectBtn!.isSelected = !selectBtn!.isSelected
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 2 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 41.5*glscale))
            view.backgroundColor = UIColor(named: "app底色")
            
            let btn = UIButton()
            view.addSubview(btn)
            btn.setImage(UIImage(named: "daixuan"), for: .normal)
            btn.setImage(UIImage(named: "yuxuan"), for: .selected)
            btn.snp.makeConstraints { (make) in
                make.centerY.equalTo(view.snp_centerY)
                make.left.equalTo(15)
                make.width.height.equalTo(12.5)
            }
            selectBtn = btn
            let btn2 = UIButton()
            view.addSubview(btn2)
            btn2.addTarget(self, action: #selector(selectBtnClick(sender:)), for: .touchUpInside)
            btn2.snp.makeConstraints { (make) in
                make.top.left.bottom.equalTo(0)
                make.width.equalTo(30)
            }
            
            let lbl1 = UILabel()
            lbl1.text = "我已阅读并同意"
            lbl1.textColor = UIColor(named: "标题字颜色")
            lbl1.font = UIFont.systemFont(ofSize: 11)
            lbl1.sizeToFit()
            view.addSubview(lbl1)
            lbl1.snp.makeConstraints { (make) in
                make.left.equalTo(btn2.snp_right).offset(3)
                make.top.bottom.equalTo(0)
                make.width.equalTo(lbl1.bounds.size.width)
            }
            
            let btn3 = UIButton()
            btn3.setTitle("《快件服务协议》", for: .normal)
            btn3.titleLabel?.font = UIFont.systemFont(ofSize: 11)
            btn3.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            btn3.tag = 99
            view.addSubview(btn3)
            btn3.sizeToFit()
            btn3.addTarget(self, action: #selector(selectBtnClick(sender:)), for: .touchUpInside)
            btn3.snp.makeConstraints { (make) in
                make.left.equalTo(lbl1.snp_right)
                make.top.bottom.equalTo(0)
                make.width.equalTo(btn3.bounds.size.width)
            }
            
            return view
        }
        let view = UIView()
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10*glscale
        }
        if section == 1 {
            return 5*glscale
        }
        return 41.5*glscale
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:return 2
        case 1:return 4
        default: return 2
        }
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if indexPath.section == 1 {
            if indexPath.row < 3 {
                print(indexPath.row)
                switch indexPath.row {
                case 0:
                    if jtwxxView == nil {
                        let view = JiTuoWuXinXiView(frame: self.view.bounds)
                        self.view.addSubview(view)
                        jtwxxView = view
                    }
                    break
                case 1:break
                default:break
                }
            }
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return 70
        }
        if indexPath.section == 1{
            if indexPath.row == 3 {
                return 96
            }
            return 49
        }
        return 49
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            let cell = tableView.dequeueReusableCell(withIdentifier: "AdressSelect") as! AdressSelectCell
            cell.titleLbl.text = "寄"
            if indexPath.row == 1 {
                cell.titleLbl.backgroundColor = UIColor(named: "标题背景色")
                cell.titleLbl.text = "收"
            }
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "PersonCenter") as! PersonCenterCell
            cell.titleLbl.text = titleArr[indexPath.row]
            if indexPath.row == 0 {
                cell.introLbl.text = "（必填）"
                cell.introLbl.textColor = UIColor(named: "蓝色字体颜色")
                cell.introLbl.isHidden = false
            }
            if indexPath.row == 2 {
                cell.introLbl.isHidden = false
            }
            if indexPath.row == 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "WenDu") as! WenDuCell
                cell.titleLbl.text = titleArr[indexPath.row]
                return cell
            }
            
            cell.contentStr = "1"
            return cell
        default:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndOnlyBtn") as! TitleAndOnlyBtnCell
            cell.titleLbl.text = title2Arr[indexPath.row]
            return cell
        }
    }
    
}
