//
//  DaiKeXiaDanGouWuViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class DaiKeXiaDanGouWuViewController: BaseViewController,UITableViewDataSource,UITableViewDelegate,DaiKeXiaDanFooterViewDelegate{
    
    let p3Arr = ["支付状态","支付方式","提货方式","出货状态","运费","其他费用"]
    var footerView:DaiKeXiaDanFooterView?
    var itemArr = NSMutableArray()
    @IBAction func submitAction(_ sender: Any) {
    }
    @IBOutlet weak var listView: UITableView!
    
    @IBOutlet weak var btmView: UILabel!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "代客下单"
        self.view.addSubview(navbar)
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(btmView.snp_top)
        }
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "DaiKeXiaDanGouWuCell", bundle: nil), forCellReuseIdentifier: "DaiKeXiaDanGouWuCell")
        //TitleAndBtnCell TitleAndTFCell
        // Do any additional setup after loading the view.
    }
    @objc func addProductAction(){
        print("添加商品")
    }
    //MARK: - cell delegate
    func addAction() {
        itemArr.add("0")
        UIView.performWithoutAnimation {
            let set = NSIndexSet(index: 1)
            listView.reloadSections(set as IndexSet, with: .none)
        }
        
    }
    //footer
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 1{
            if itemArr.count == 0 {
                return 142
            }
            return 220
        }
        return 10
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 1{//220 142
           let view = DaiKeXiaDanFooterView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 220))
            view.topView.isHidden = false
            if itemArr.count == 0 {
                view.topView.isHidden = true
                view.topViewHeight.constant = 0.01
            }
            view.delegate = self
            footerView = view
            return footerView
        }
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let  view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            view.backgroundColor = UIColor.white
            let lbl = UILabel()
            lbl.text = "商品清单"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.bottom.right.equalTo(0)
                make.left.equalTo(15)
            }
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            return 39
        }
        return 0.01
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:return 2
        case 1:return itemArr.count
        default:return 6
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            return 120
        }
        return 49
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
            cell.nameLbl.text = "客户："
            if indexPath.row == 1 {
                cell.nameLbl.text = "订单类型："
            }
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "DaiKeXiaDanGouWuCell") as! DaiKeXiaDanGouWuCell
            return cell
        default:
            if indexPath.row < 4 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.nameLbl.text = p3Arr[indexPath.row]
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.nameLbl.text = p3Arr[indexPath.row]
            cell.textTF.snp.makeConstraints { (make) in
                make.centerY.equalTo(cell.snp_centerY)
                make.right.equalTo(-15)
                make.width.equalTo(95)
                make.height.equalTo(32)
            }
            cell.textTF.layer.cornerRadius = 3
            cell.textTF.layer.masksToBounds = true
            cell.textTF.layer.borderWidth = 1
            cell.textTF.layer.borderColor = UIColor(named: "灰色字体颜色")?.cgColor
            cell.textTF.placeholder = "请输入运费"
            cell.textTF.textColor = UIColor(named: "蓝色字体颜色")
            if indexPath.row == 5 {
                cell.textTF.placeholder = "请输入费用"
            }
            cell.textTF.textAlignment = .center
            return cell
        }
        
    }
    
}
