//
//  ProductDetailViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class ProductDetailViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,CommendCellDelegate,TitleAndBtnCellDelegate,GLAlertSelectViewDelegate{
    
    var glSelectView:GLAlertSelectView?
    let titleArr = ["商品信息","商品图片","商品规格","预售设置","其它信息","商品详情"]
    let spxxArr = ["商品名称","商品类型","商品分类","品牌","起卖数量","是否清真","是否询价"]
    let sptpArr = ["商品封面图(限一张)","商品主图(限五张)"]
    let qtxxArr = ["关键字","物流费用","国家","商品状态","运输方式"]
    let ysszArr = ["用户付款是否需要审核","预设预付定金时间段","预设预付尾款时间段","预设预付尾款发货时间"]
    @IBAction func submitAction(_ sender: Any) {
    }
    @IBOutlet weak var submitBtn: LGButton!
    @IBOutlet weak var listTbv: UITableView!
    var cellHeight = 18.5
    var contentStr:String = ""
    
    var guiGeArr:Array<Any> = []//根据规格资料数量控制右上角新增按钮是否显示
    //
    @IBOutlet weak var lgBtnLbl: UILabel!
    @IBOutlet weak var btmView: UIView!
    let btmTitleArr = ["编辑","入库","下架","删除"]
  
    var isYuShouShangPin:Bool?
    
    @objc func bottomBtnClick(sender:UIButton){
        print(sender.titleLabel?.text)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        isYuShouShangPin = true
//        if 浏览状态 {
        let w = fullScreenWidth / CGFloat(btmTitleArr.count)
        lgBtnLbl.isHidden = true
        submitBtn.isHidden = true
        for i in 0 ..< btmTitleArr.count{
            let btn = UIButton(frame: CGRect(x: CGFloat(i) * w, y: 0, width: w, height: btmView.bounds.size.height))
            btn.tag = i
            btn.setTitle(btmTitleArr[i], for: .normal)
            btn.titleLabel?.textColor = UIColor.clear
            btn.addTarget(self, action: #selector(bottomBtnClick(sender:)), for: .touchUpInside)
            let lbl = UILabel(frame: CGRect(x: CGFloat(i) * w, y: 0, width: w, height: 49*glscale))
            lbl.textAlignment = .center
            lbl.text = btmTitleArr[i]
            lbl.font = UIFont.systemFont(ofSize: 13)
            lbl.textColor = UIColor(named: "蓝色字体颜色")
            btmView.addSubview(btn)
            btmView.addSubview(lbl)
        }
//        }
        
        navbar.title = "商品详情"
        self.view.addSubview(navbar)
        listTbv.separatorStyle = .none
        listTbv.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(submitBtn.snp_top)
        }
        
        listTbv.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        listTbv.register(UINib(nibName: "TitleAndSwitchCell", bundle: nil), forCellReuseIdentifier: "TitleAndSwitch")
        listTbv.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        listTbv.register(UINib(nibName: "AddImgCell", bundle: nil), forCellReuseIdentifier: "AddImg")
        listTbv.register(UINib(nibName: "AddGuiGeCell", bundle: nil), forCellReuseIdentifier: "AddGuiGe")
        listTbv.register(UINib(nibName: "CommendCell", bundle: nil), forCellReuseIdentifier: "Commend")
        listTbv.register(UINib(nibName: "YuShouWeiKuanFaHuoCell", bundle: nil), forCellReuseIdentifier: "YuShouWeiKuanFaHuoCell")
        // Do any additional setup after loading the view.
    }
    //MARK: - cell delegate
    func numberOfSections(in tableView: UITableView) -> Int {
        return 6
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0: return 7
        case 1:return 2
        case 2:return 1
        case 3:return 4
        case 4:return 5
        default:return 2
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            if indexPath.row == 0 || indexPath.row == 4 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
                cell.nameLbl.text = spxxArr[indexPath.row]
                return cell
            }
            if indexPath.row > 4{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSwitch") as! TitleAndSwitchCell
                cell.namelbl.text = spxxArr[indexPath.row]
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
            cell.nameLbl.text = spxxArr[indexPath.row]
            cell.delegate = self
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "AddImg") as! AddImgCell
            cell.nameLbl.text = sptpArr[indexPath.row]
            cell.addBtn.addTarget(self, action: #selector(addImageAction), for: .touchUpInside)
            cell.addBtn.tag = indexPath.row
            return cell
        case 2:
            let cell = tableView.dequeueReusableCell(withIdentifier: "AddGuiGe") as! AddGuiGeCell
            cell.imgBtn.addTarget(self, action: #selector(addGuiGe), for: .touchUpInside)
            return cell
        case 3:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSwitch") as! TitleAndSwitchCell
                cell.namelbl.text = ysszArr[indexPath.row]
                return cell
            }
            if indexPath.row == 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "YuShouWeiKuanFaHuoCell") as! YuShouWeiKuanFaHuoCell
                cell.nameLbl.text = ysszArr[indexPath.row]
                cell.textTF.keyboardType = .numberPad
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
            cell.nameLbl.text = ysszArr[indexPath.row]
            cell.delegate = self
            return cell
        case 4:
            if indexPath.row < 2 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
                cell.nameLbl.text = qtxxArr[indexPath.row]
                return cell
            }else{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
                cell.nameLbl.text = qtxxArr[indexPath.row]
                cell.delegate = self
                return cell
            }
        default:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "Commend") as! CommendCell
                cell.delegate = self
                return cell
            }else{
                let cell = tableView.dequeueReusableCell(withIdentifier: "AddGuiGe") as! AddGuiGeCell
                cell.imgBtn.setImage(UIImage(named: "tupian"), for: .normal)
                cell.imgBtn.addTarget(self, action: #selector(addImgAction), for: .touchUpInside)
                return cell
            }
        }
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        switch indexPath.section {
        case 0: return 49*glscale
        case 1:return 148.5*glscale
        case 2:return 123.5*glscale
        case 3:
            if isYuShouShangPin == false {
                return 0.01
            }else{
                return 49*glscale
            }
        case 4:return 49*glscale
        default:
            if indexPath.row == 0 {
                return CGFloat(cellHeight)+27.5
            }else{
                return 155.5
            }
        }
    }
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 3 {
            if isYuShouShangPin == false {
                return UIView()
            }
        }
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39*glscale))
        let lbl = UILabel(frame: CGRect(x: 15*glscale, y: 15*glscale, width: fullScreenWidth, height: 21*glscale))
        lbl.text = titleArr[section]
        lbl.textColor = UIColor(named: "标题字颜色")
        lbl.font = UIFont.boldSystemFont(ofSize: 15)
        view.addSubview(lbl)
        if section == 2 && guiGeArr.count > 0{
            let btn = UIButton()
            btn.setTitle(" 新增", for: .normal)
            btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            btn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            btn.setImage(UIImage(named: "编组"), for: .normal)
            view.addSubview(btn)
            btn.sizeToFit()
            btn.snp.makeConstraints { (make) in
                make.centerY.equalTo(lbl.snp_centerY)
                make.right.equalTo(-15)
                make.height.equalTo(btn.frame.size.height)
                make.width.equalTo(btn.frame.size.width)
            }
            let btn2 = UIButton()
            btn2.backgroundColor = UIColor.black
            view.addSubview(btn2)
            btn2.snp.makeConstraints { (make) in
                make.top.right.bottom.equalTo(0)
                make.width.equalTo(80)
            }
        }
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 3 {
            if isYuShouShangPin == false {
                return 0.001
            }
        }
        return 39*glscale
    }
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10*glscale))
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 3 {
               if isYuShouShangPin == false {
                   return 0.001
               }
           }
        return 10*glscale
    }
    //MARK: - 自定义delegate
    func CommendCellSendH(height: CGFloat) {
        cellHeight = Double(height)
        listTbv.beginUpdates()
        listTbv.endUpdates()
    }
    func CommendCellSendStr(content: String) {
        
    }
    override func backAction() {
        self.navigationController?.popViewController(animated: true)
    }
    func btnClick(content: String, cell: TitleAndBtnCell) {        if cell.nameLbl.text == "商品类型" {
        if glSelectView == nil {
            let view = GLAlertSelectView(frame: self.view.bounds)
            view.isMultipleSelect = true
            view.titleLbl.text = "请选择仓库类型"
            view.delegate = self
            view.dataArr = ["预售","普通","期货","团购"]
            self.view.addSubview(view)
            glSelectView = view
        }
        }
        if cell.nameLbl.text == "商品分类" {
            
        }
        if cell.nameLbl.text == "品牌" {
            
        }
        if cell.nameLbl.text == "国家" {
            
        }
        if cell.nameLbl.text == "商品状态" {
            
        }
        if cell.nameLbl.text == "运输方式" {
            
        }
        if cell.nameLbl.text == "预设预付定金时间段" {
            
        }
        if cell.nameLbl.text == "预设预付尾款时间段" {
            
        }
        print(cell.nameLbl.text)
    }
    func GLAlertSelectViewClick(selectNum: Int, view: UIView) {
        print("单选",selectNum)
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    
    func GLAlertMoreSelectViewClick(sender: NSArray, view:UIView) {
        print("多选",sender)
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    func GLAlertSelectViewClose(sender: UIButton) {
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    @objc func addImgAction(){
        print("添加图片")
        
    }
    @objc func addGuiGe(){
        print("新增规格")
        let vc = CreatNewSpecsViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    @objc func addImageAction(sender:UIButton){
        print(sender.tag)
    }
}
