//
//  ZengZhiServicesViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class ZengZhiServicesViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndSelectCellDelegate,UITextViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelect") as! TitleAndSelectCell
        cell.delegate = self
        cell.tag = indexPath.row
        cell.titleLbl.text = titleArr[indexPath.row]
        let line = UIView()
        line.backgroundColor = UIColor(named: "灰色分界线")
        cell.contentView.addSubview(line)
        line.snp.makeConstraints { (make) in
            make.bottom.right.equalTo(0)
            make.left.equalTo(15)
            make.height.equalTo(1)
        }
        return cell
    }
    
    func TitleAndSelectCellClick(content: UIButton, cell: TitleAndSelectCell) {
        print(cell.tag)
        for item in listView.visibleCells {
            let cel = item as! TitleAndSelectCell
            cel.selectBtn.isSelected = false
            if cel == cell {
                cel.selectBtn.isSelected = true
            }
        }
    }
    @IBAction func submitAction(_ sender: Any) {
        print("submit")
    }
    
    var titleArr = ["送货入仓","清真","易污染"]
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var nBtn: UIButton!
    @IBOutlet weak var pBtn: UIButton!
    @IBOutlet weak var eBtn: UIButton!
    @IBOutlet weak var textView: UITextView!
    @IBOutlet weak var countingLbl: UILabel!
    @IBOutlet weak var textViewHolderLbl: UILabel!
    @IBOutlet weak var priceTLbl: UILabel!
    @IBOutlet weak var priceLbl: UILabel!
    @IBOutlet weak var inputTF: UITextField!
    @IBOutlet weak var holderLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "增值服务"
        self.view.addSubview(navbar)
        
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(139.5)
        }
        listView.isScrollEnabled = false
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelect")
        textView.delegate = self
        
        inputTF.addTarget(self, action: #selector(textViewEdit(sender:)), for: .allEditingEvents)
        nBtn.isSelected = true
        nBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        nBtn.layer.borderWidth = 0
        
        // Do any additional setup after loading the view.
    }
    func textViewDidChange(_ textView: UITextView) {
        if textView.text.count != 0 {
            textViewHolderLbl.isHidden = true
        }else{
            textViewHolderLbl.isHidden = false
        }
    }
    func textView(_ textView: UITextView, shouldChangeTextIn range: NSRange, replacementText text: String) -> Bool {
        countingLbl.text = "\(textView.text.count)/50"
        if (textView.text.count == 50)
        {
            return false//限制长度
        }
        return true
    }
    
    
    @objc func textViewEdit(sender:UITextView){
        if sender.text.count > 0 {
            holderLbl.isHidden = true
        }else{
            holderLbl.isHidden = false
        }
    }
    @IBAction func selectAction(_ sender: UIButton) {
        if sender == nBtn{
            if nBtn.isSelected == true {
                nBtn.isSelected = false
                nBtn.backgroundColor = UIColor.clear
                nBtn.layer.borderWidth = 1
            }else{
                pBtn.backgroundColor = UIColor.clear
                pBtn.isSelected = false
                pBtn.layer.borderWidth = 1
                eBtn.backgroundColor = UIColor.clear
                eBtn.isSelected = false
                eBtn.layer.borderWidth = 1
                
                nBtn.isSelected = true
                nBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                nBtn.layer.borderWidth = 0
            }
        }
        if sender == pBtn {
            if pBtn.isSelected == true {
                pBtn.isSelected = false
                pBtn.backgroundColor = UIColor.clear
                pBtn.layer.borderWidth = 1
            }else{
                nBtn.backgroundColor = UIColor.clear
                nBtn.isSelected = false
                nBtn.layer.borderWidth = 1
                eBtn.backgroundColor = UIColor.clear
                eBtn.isSelected = false
                eBtn.layer.borderWidth = 1
                
                pBtn.isSelected = true
                pBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                pBtn.layer.borderWidth = 0
            }
        }
        if sender == eBtn{
            if eBtn.isSelected == true {
                eBtn.isSelected = false
                eBtn.backgroundColor = UIColor.clear
                eBtn.layer.borderWidth = 1
            }else{
                nBtn.backgroundColor = UIColor.clear
                nBtn.isSelected = false
                nBtn.layer.borderWidth = 1
                pBtn.backgroundColor = UIColor.clear
                pBtn.isSelected = false
                pBtn.layer.borderWidth = 1
                
                eBtn.isSelected = true
                eBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                eBtn.layer.borderWidth = 0
            }
        }
        
    }
}
