//
//  KuCunShangPinXQViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class KuCunShangPinXQViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource{
    
    
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var detailLbl2: UILabel!
    @IBOutlet weak var detailLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var imgView: UIImageView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "商品-xxxx"
        self.view.addSubview(navbar)
        
        let maskPath = UIBezierPath(roundedRect: topView.bounds,
        byRoundingCorners:[.bottomLeft, .bottomRight], cornerRadii:CGSize(width:3, height:3))
        let masklayer = CAShapeLayer()
        masklayer.frame = topView.bounds
        masklayer.path = maskPath.cgPath
        topView.layer.mask = masklayer
        
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.right.left.equalTo(0)
            make.height.equalTo(120)
        }
        
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "KuCunXiangQingCell", bundle: nil), forCellReuseIdentifier: "KuCunXiangQingCell")
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 70))
        view.backgroundColor =  UIColor(named: "app底色")
        let t1 = UILabel()
        t1.text = "商品可售库存："
        t1.font = UIFont.systemFont(ofSize: 13)
        t1.textColor = UIColor(named: "标题字颜色")
        t1.sizeToFit()
        view.addSubview(t1)
        t1.snp.makeConstraints { (make) in
            make.top.left.equalTo(15)
            make.width.equalTo(t1.bounds.size.width)
            make.height.equalTo(18.5)
        }
        let kcL = UILabel()//可售库存
        kcL.text = "1010"
        kcL.font = UIFont.systemFont(ofSize: 13)
        kcL.textColor = UIColor(named: "蓝色字体颜色")
        view.addSubview(kcL)
        kcL.snp.makeConstraints { (make) in
            make.centerY.equalTo(t1.snp_centerY)
            make.left.equalTo(t1.snp_right)
            make.height.equalTo(18.5)
        }
        
        let zkcL = UILabel()//总库存
        zkcL.text = "10111110"
        zkcL.font = UIFont.systemFont(ofSize: 13)
        zkcL.textColor = UIColor(named: "蓝色字体颜色")
        zkcL.sizeToFit()
        view.addSubview(zkcL)
        zkcL.snp.makeConstraints { (make) in
            make.centerY.equalTo(t1.snp_centerY)
            make.right.equalTo(-15)
            make.width.equalTo(zkcL.bounds.size.width)
            make.height.equalTo(18.5)
        }
        let t2 = UILabel()
        t2.text = "商品总库存："
        t2.font = UIFont.systemFont(ofSize: 13)
        t2.textColor = UIColor(named: "标题字颜色")
        view.addSubview(t2)
        t2.snp.makeConstraints { (make) in
            make.centerY.equalTo(t1.snp_centerY)
            make.height.equalTo(18.5)
            make.right.equalTo(zkcL.snp_left)
        }
        
        let title = UILabel()
        title.text = "库存详情"
        title.font = UIFont.boldSystemFont(ofSize: 17)
        title.textColor = UIColor(named: "标题字颜色")
        view.addSubview(title)
        title.snp.makeConstraints { (make) in
            make.top.equalTo(t1.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(21)
        }
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 70
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 280
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "KuCunXiangQingCell") as! KuCunXiangQingCell
        cell.shengChanLbl.attributedText = self.setStrLine(lbl: cell.shengChanLbl)
        cell.guoQiLbl.attributedText = self.setStrLine(lbl: cell.guoQiLbl)
        cell.ruKuLbl.attributedText = self.setStrLine(lbl: cell.ruKuLbl)
        cell.baoZhiQiLbl.attributedText = self.setStrLine(lbl: cell.baoZhiQiLbl)
        return cell
    }
    func setStrLine(lbl:UILabel)->NSAttributedString{
        let attributedString = NSMutableAttributedString(string: lbl.text!)
        let arr = lbl.text?.components(separatedBy: "：")
        let string = arr?.first
        let str = arr?.last
        attributedString.addAttribute(.underlineStyle, value: NSUnderlineStyle.single.rawValue, range: NSRange(location: string!.count+1, length: str!.count))
        return attributedString
    }
    
}
