//
//  CheckWareHourseViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/18.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import IQKeyboardManagerSwift

class CheckWareHourseViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,WareHouseSpCellDelegate,GLAlertSelectViewDelegate{
    
    var titleStr:String?
    @IBOutlet weak var bottomBtn: LGButton!
    @IBOutlet weak var color: LGButton!
    @IBOutlet weak var listView: UITableView!
    
    var btnArray:NSMutableArray = NSMutableArray()
    var statusStr:String = ""
    var warehourseType:Int = 99
    var warehourseTypeSelectView:UIView? = nil
    
    let titleArr = ["仓库名称：","仓库类型：","包含库位：","仓库地址：","仓库容积：","仓库面积：","联系人：","联系人电话："]
    let placeHArr = ["请输入仓库名称","请选择仓库类型","请输入库位名","请输仓库地址","请输入仓库容积","请输入仓库面积","请输入联系人","请输入联系人电话"]
    
    
    var listArray = ["a","b","c"]
    var glSelectView:GLAlertSelectView?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = titleStr
        self.view.addSubview(navbar)
        if titleStr != "新增仓库" {
            bottomBtn.titleString = "编辑"
            navbar.rightTitle = "删除"
        }
        listView.delegate = self
        listView.dataSource = self
        listView.separatorStyle = .none
        listView?.register(UINib(nibName: "WareHouseSpCell", bundle: nil), forCellReuseIdentifier: "WareHouse")
        listView.isScrollEnabled = false
        
        color.isUserInteractionEnabled = false
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomBtn.snp_top)
        }
        // Do any additional setup after loading the view.
    }
    
    //MARK: -方法
    func GLAlertSelectViewClose(sender: UIButton) {
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    @IBAction func submitAction(_ sender: LGButton) {
     
        
        if sender.tag == 999 {//请选择或填写包含库位的确定按钮
            print("tag 999")
        }else{
            if sender.titleString == "确定"{
                print("确定 -- 仓库类型：\(warehourseType) (0:冷冻、1:冷藏、2:常温)")
            }else{
                if sender.titleString == "保存" {
                    sender.titleString = "编辑"
                    statusStr = sender.titleString
                    
                }else{
                    sender.titleString = "保存"
                    statusStr = sender.titleString
                }
                listView.reloadData()
            }
        }
    }
    //MARK: - delegate
    func rightBtnClick() {
        print("删除")
    }
    
   
    @objc func removeActin(sender:UIButton){
        sender.superview?.removeFromSuperview()
    
    }
    
    //MARK: - 自定义DELEGATE
    //库位
    func GLAlertSelectDelAction(sender:Array<Any>) {
        print(sender)
    }
    func GLAlertSelectEditAction(sender: Int) {
        print(sender)
    }
    
    func GLAlertSelectSubmitAction() {
        print("确定")
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    func clickAction(sender: UIButton) {
        IQKeyboardManager.shared.resignFirstResponder()
        if sender.tag == 1 {//新增仓库类型
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.titleLbl.text = "请选择仓库类型"
                view.delegate = self
                view.dataArr = listArray
                self.view.addSubview(view)
                glSelectView = view
            }
        }
        if sender.tag == 2 {//MARK: -包含库位
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds,title:"请选择或填写包含库位")
                view.delegate = self
                view.dataArr = listArray
                self.view.addSubview(view)
                glSelectView = view
            }
        }
    }
   
    func setBtn(tagView:UIView,title:String,tag:Int)->UIView{
        let view = UIView(frame: CGRect(x: 0, y: tagView.frame.maxY, width: fullScreenWidth, height: 49*glscale))
        
        let title1 = UILabel(frame: CGRect(x: 15, y: 0, width: fullScreenWidth, height: 49*glscale))
        title1.text = title
        title1.font = UIFont.systemFont(ofSize: 13)
        title1.textColor = UIColor(named: "标题字颜色")
        view.addSubview(title1)
        let btn = UIButton(frame: CGRect(x: fullScreenWidth-34*glscale, y: (49-19)*0.5*glscale, width: 19*glscale, height: 19*glscale))
        btn.setImage(UIImage(named: "daixuan"), for: .normal)
        btn.setImage(UIImage(named: "yuxuan"), for: .selected)
        btn.tag = tag
        btn.addTarget(self, action: #selector(typeSelect(sender:)), for: .touchUpInside)
        view.addSubview(btn)
        btnArray.add(btn)
        
        let line = UIView(frame: CGRect(x: 15, y: title1.frame.maxY, width: fullScreenWidth-30, height: 1))
        line.backgroundColor = UIColor(named: "灰色分界线")
        view.addSubview(line)
        
        return view
    }
    @objc func typeSelect(sender:UIButton){
        for item in btnArray {
            let btn:UIButton = item as! UIButton
            if sender.tag == btn.tag {
                btn.isSelected = true
                warehourseType = btn.tag
            }else{
                btn.isSelected = false
            }
        }
    }
    override func backAction() {
        print("重写back")
        self.navigationController?.popViewController(animated: true)
    }
    // MARK: - cell delegate
    func numberOfSections(in tableView: UITableView) -> Int {
        if tableView == listView {
            return 2
        }
        return 1
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == listView {
            if section == 0 {
                return titleArr.count
            }
            return 1
        }else{
            return listArray.count
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    
    
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {

        let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 10))
        view.backgroundColor = UIColor(named: "app背景色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
   
        return 10
    }
    
    func setCellLayout(cell:WareHouseSpCell,indexPath:IndexPath){
        cell.detailTF.snp.updateConstraints{ (make) in
            make.left.equalTo(cell.titleLbl.snp_right)
            make.top.bottom.equalTo(0)
            make.right.equalTo(-15)
        }
        if titleStr == "新增仓库" || statusStr == "保存"{
            cell.detailTF.isUserInteractionEnabled = true
            cell.whSwitch.isUserInteractionEnabled = true
            cell.btnImg.isHidden = true
            cell.clickBtn.isHidden = false
            if indexPath.row == 1 || indexPath.row == 2 {
                cell.btnImg.isHidden = false
                cell.clickBtn.isHidden = false
                cell.clickBtn.tag = indexPath.row
                cell.detailTF.snp.updateConstraints { (make) in
                    make.left.equalTo(cell.titleLbl.snp_right)
                    make.top.bottom.equalTo(0)
                    make.right.equalTo(-45)
                }
                if indexPath.row == 1 {
                    cell.btnImg.image = UIImage(named: "jinru")
                    cell.btnImg.snp.makeConstraints { (make) in
                        make.centerY.equalTo(cell.titleLbl.snp_centerY)
                        make.right.equalTo(-15)
                        make.width.equalTo(5)
                        make.height.equalTo(9)
                    }
                    cell.detailTF.snp.updateConstraints { (make) in
                        make.left.equalTo(cell.titleLbl.snp_right)
                        make.top.bottom.equalTo(0)
                        make.right.equalTo(-35)
                    }
                }
            }
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
       
        let cell = tableView.dequeueReusableCell(withIdentifier: "WareHouse") as! WareHouseSpCell
            cell.clickBtn.isHidden = true
            cell.detailTF.isUserInteractionEnabled = false
            cell.whSwitch.isUserInteractionEnabled = false
            if indexPath.section == 0 {//仓库名称等
                cell.whSwitch.isHidden = true
                cell.delegate = self
                cell.titleLbl.text = titleArr[indexPath.row]
                cell.detailTF.placeholder = placeHArr[indexPath.row]
                cell.btnImg.isHidden = true
                
                //cell ui 布局
                self.setCellLayout(cell: cell, indexPath: indexPath)
            }else{//默认仓库
                cell.detailTF.isHidden = true
                cell.clickBtn.isHidden = true
                cell.btnImg.isHidden = true
            }
            return cell
        
    }
}
