//
//  CreatNewSpecsViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/21.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class CreatNewSpecsViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndTFCellDelegate,TitleAndBtnCellDelegate,TitleAndSwitchCellDelegate,TitleAndSwitchHeaderViewDelegate,NewCreateHeaderDelegate,NewCreateFooterDelegate,YuShouCellDelegate,GLAlertSelectViewDelegate{
    
    let titleArray = ["售价：","规格：","重量：","温藏：","单位："]
    let pliceHolderArr = ["请输入商品售价","请输入商品规格","请输入商品重量","请选择商品温藏","请选择商品单位"]
    @IBOutlet weak var bottomBtn: LGButton!
    @IBOutlet weak var listTbv: UITableView!
    
    var isYuShouSetting: Bool = false
    var isJieTiJiaSetting: Bool = false
    
    var selectYuShou:Bool = false//是否选择设置预售价格
    
    var isSelectNonYuShou:Bool = true //跳转前确定是否能选择预售
    //规格
    var normalArr:NSArray = []//普通
    var specalArr:NSArray = []//预售
    
    //选择页面
    var selectView:GLAlertSelectView? = nil
    var selectListArr:Array<String> = ["a","b","c"]
    //测试数据
    var addNormal = 0
    var addSpecal = 0
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "新增规格"
        self.view.addSubview(navbar)
        
        listTbv.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomBtn.snp_top)
        }
        
        
        listTbv?.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        listTbv?.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        listTbv?.register(UINib(nibName: "TitleAndSwitchCell", bundle: nil), forCellReuseIdentifier: "TitleAndSwitch")
        listTbv?.register(UINib(nibName: "YuShouCell", bundle: nil), forCellReuseIdentifier: "YuShou")
        listTbv?.register(UINib(nibName: "PuTongJieTiCell", bundle: nil), forCellReuseIdentifier: "PuTongJieTi")
        listTbv?.register(UINib(nibName: "DelGuiGeCell", bundle: nil), forCellReuseIdentifier: "DelGuiGe")
        
    }
    
    
    
    @IBAction func saveAction(_ sender: Any) {
        print("save")
        
    }
    //MARK: - cell delegate
    func numberOfSections(in tableView: UITableView) -> Int {
      
        if (navbar.title?.contains("编辑"))! {
            return 4
        }else{
            return 3
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        if section == 0 {
            return titleArray.count
        }
        if section == 2 {
            if selectYuShou {//预售
                if normalArr.count == 0{
                    return addNormal
                }else{
                    return normalArr.count
                }
            }else{//非预售
                if specalArr.count == 0 {
                    return addSpecal
                }else{
                    return specalArr.count
                }
            }
        }
        return 1
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {

        if indexPath.section == 0 {
            if indexPath.row < 3 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
                cell.nameLbl.text = titleArray[indexPath.row]
                cell.tag = indexPath.row
                let str = NSAttributedString(string: pliceHolderArr[indexPath.row], attributes: [NSAttributedString.Key.foregroundColor:UIColor(named: "灰色字体颜色")])
                cell.textTF.attributedPlaceholder = str
                cell.delegate = self
                return cell
            }else{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
                cell.tag = indexPath.row
                cell.delegate = self
                cell.nameLbl.text = titleArray[indexPath.row]
                cell.contentLbl.text = pliceHolderArr[indexPath.row]
                return cell
            }
        }
        
        
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSwitch") as! TitleAndSwitchCell
        cell.delegate = self
        cell.namelbl.font = UIFont.boldSystemFont(ofSize: 15)
        if indexPath.section == 1{
            cell.namelbl.text = "预售设置"
            cell.infoSw.isOn = isYuShouSetting
            cell.tag = 5
            if isSelectNonYuShou {
                cell.namelbl.alpha = 0.45
                cell.isUserInteractionEnabled = false
                
            }
        }
        if indexPath.section == 1 {
            if isYuShouSetting {
                let cell = tableView.dequeueReusableCell(withIdentifier: "YuShou") as! YuShouCell
                cell.tag = indexPath.row
                cell.infoSw.isOn = isYuShouSetting
                cell.delegate = self
                return cell
            }
        }
        if indexPath.section == 2 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "PuTongJieTi") as! PuTongJieTiCell
            cell.titleLbl.text = "\(indexPath.row+1).数量≥"
            return cell
        }
        if indexPath.section == 3 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "DelGuiGe") as! DelGuiGeCell
            return cell
        }
        return cell
        
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            if isYuShouSetting {
                return 184.5
            }
        }
        if indexPath.section == 2 {
            if isJieTiJiaSetting {
                return 49
            }else{
                return 0.001
            }
        }
        return 49
    }
    
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView()
        if section == 2 {
            let view = NewCreateHeader(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
            view.delegate = self
            view.infoSw.isOn = isJieTiJiaSetting
            
            if isJieTiJiaSetting == false{
                return view
            }
            if isYuShouSetting {
                let view = TitleAndSwitchHeaderView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 90))
                view.delegate = self
                view.selectYuShou = selectYuShou
                view.infoSW.isOn = isJieTiJiaSetting
                return view
            }
            return view
        }
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section != 0 {
            if section == 2 {
                if isYuShouSetting && isJieTiJiaSetting {
                    return 90
                }
                return 59
            }
            return 10
        }
        return 0.01
    }
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 2 {
            if isJieTiJiaSetting {
                let view = NewCreateFooter(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
                view.delegate = self
                return view
            }
        }
        let view = UIView()
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 2 {
            if isJieTiJiaSetting {
                return 49
            }
        }
        return 0.01
    }
    //MARK: - NEW CELL DELEGATE
    func textFieldContent(content: String, cell: TitleAndTFCell) {
        
    }
    
    func GLAlertSelectViewClose(sender: UIButton) {
        print("关闭")
        selectView?.removeFromSuperview()
        selectView = nil
    }
    func GLAlertSelectViewClick(sender: Int, view:UIView) {
        print(sender)
        selectView?.removeFromSuperview()
        selectView = nil
    }
   
    func btnClick(content: String, cell: TitleAndBtnCell) {
        if cell.tag == 3 {
            if selectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.titleLbl.text = "请选择商品温藏"
                view.delegate = self
                view.dataArr = selectListArr
                self.view.addSubview(view)
                selectView = view
            }
        }else{
            if selectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.titleLbl.text = "请选择商品单位"
                view.delegate = self
                view.dataArr = selectListArr 
                self.view.addSubview(view)
                selectView = view
            }
        }
        
    }
    func switchStatus(sender: UISwitch) {
        isJieTiJiaSetting = sender.isOn
        listTbv.reloadData()
    }
    func switchClick(content: UISwitch, cell: TitleAndSwitchCell) {
        if cell.tag == 5{
            isYuShouSetting = content.isOn
            let idxPath = IndexPath(row: 0, section: 1)
            if isYuShouSetting && isJieTiJiaSetting {
                listTbv.reloadData()
            }else{
                listTbv.reloadRows(at: [idxPath], with: .none)
            }
        }
        
    }
    func newCreateSwitchStatus(sender: UISwitch) {
        isJieTiJiaSetting = sender.isOn
        listTbv.reloadData()
    }
    
    func footerClickAction() {
        if selectYuShou {//预售
            addNormal += 1
        }else{//非预售
            addSpecal += 1
        }
        listTbv.reloadData()
    }
    func YuShouCellSwitchStatus(sender: UISwitch) {
        isYuShouSetting = sender.isOn
        listTbv.reloadData()
    }
    
    func selectYuShou(sender: UIButton) {
        if sender.tag == 0 {
            selectYuShou = false
            addNormal = normalArr.count
        }else{
            selectYuShou = true
            addSpecal = specalArr.count
        }
        listTbv.reloadData()
    }
    
    //MARK: - 选择页面
   
    
        
    
}
