//
//  TitleAndSwitchHeaderView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol TitleAndSwitchHeaderViewDelegate {
    @objc optional func switchStatus(sender:UISwitch)
    @objc optional func selectYuShou(sender:UIButton)
}
class TitleAndSwitchHeaderView: UIView {
    @IBOutlet weak var rightBtn: UIButton!
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var bottomLine: UIView!
    var selectYuShou:Bool = false{
        didSet{
            var sender = 0
            if selectYuShou {
                sender = 1
                leftBtn.setTitleColor(UIColor(named: "标题字颜色"), for: .normal)
                rightBtn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
            }else{
                leftBtn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
                rightBtn.setTitleColor(UIColor(named: "标题字颜色"), for: .normal)
                
            }
            let x = CGFloat(sender)*fullScreenWidth*0.5
            bottomLine.snp.updateConstraints { (make) in
                make.left.equalTo(x)
                make.bottom.equalTo(0)
                make.width.equalTo(fullScreenWidth*0.5)
                make.height.equalTo(1.5)
            }
        }
    }
    var contentView:UIView!
    var delegate:TitleAndSwitchHeaderViewDelegate?
    @IBOutlet weak var infoSW: UISwitch!
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        
        infoSW.transform = CGAffineTransform(scaleX: 0.8, y: 0.8)
        infoSW.addTarget(self, action: #selector(switchChange(sender:)), for: .valueChanged)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        return view
    }
    @IBAction func btnClick(_ sender: UIButton) {
        delegate?.selectYuShou?(sender: sender)
        if sender == leftBtn {
            leftBtn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
            rightBtn.setTitleColor(UIColor(named: "标题字颜色"), for: .normal)
            
        }else{
            leftBtn.setTitleColor(UIColor(named: "标题字颜色"), for: .normal)
            rightBtn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
        }
        let x = CGFloat(sender.tag)*fullScreenWidth*0.5
        bottomLine.snp.updateConstraints { (make) in
            make.left.equalTo(x)
            make.bottom.equalTo(0)
            make.width.equalTo(fullScreenWidth*0.5)
            make.height.equalTo(1.5)
        }
    }
    @objc func switchChange(sender:UISwitch){
        delegate?.switchStatus?(sender: sender)
    }
}
