//
//  LoginViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/14.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Alamofire
import CryptoSwift
import LGButton

protocol loginDelegate {
    func successLogin()
}
class LoginViewController: BaseViewController, CodeViewDelegate,GeliAlertViewDelegate {
  
    var delegate :loginDelegate?
    //MARK: - 输入账号、密码、验证码
    @IBOutlet weak var loginBtn: LGButton!
    @IBOutlet weak var codeView: UIView!
    @IBOutlet weak var phoneTF: UITextField!
    @IBOutlet weak var passTF: UITextField!
    @IBOutlet weak var codeTF: UITextField!
    @IBOutlet weak var bannerImg: UIImageView!
    @IBOutlet weak var topImg: UIImageView!
    @IBOutlet weak var shBtn: UIButton!
    var codeNum: String = ""
    //MARK: - viewWillAppear
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.view.backgroundColor = UIColor(named:"白色背景色")

    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        passTF.isSecureTextEntry = true
        bannerImg.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(0)
            make.height.equalTo(234*glscale)
        }
        topImg.snp.makeConstraints { (make) in
            make.bottom.equalTo(bannerImg.snp_top)
            make.left.right.equalTo(0)
            make.height.equalTo(60)
        }
        let codeV = CaptchaView(frame:codeView.bounds)
        codeV.delegate = self
        codeView.addSubview(codeV);
        codeV.changeCaptcha()
    }
   
    //MARK: -跳转忘记密码,登录
    @IBAction func forgetPasswordAction(_ sender: Any) {
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = "020-81338860"
        alertView.titileLbl.text = "如忘记密码，请联系后台人员修改密码，请联系："
        self.view.window?.addSubview(alertView)
    }
    func sureAction(sender: UIButton) {
        UIApplication.shared.openURL(NSURL.init(string: "tel://020-81338860")! as URL)

    }
    
    @IBAction func shPassAction(_ sender: UIButton) {
        shBtn.isSelected = !shBtn.isSelected
        passTF.isSecureTextEntry = !shBtn.isSelected
    }
    func getCodeNum(num: String) {
        codeNum = num
    }
    @IBAction func loginAction(_ sender: Any) {
        //MARK:--登录接口样式
        print("\(codeNum) == \(codeTF.text)")
//    zxpf
//    123456
        if phoneTF.text?.count == 0 {
            HUD.flash(.label("请填写用户名"), delay: 1.2)
            return
        }
        if passTF.text?.count == 0 {
            HUD.flash(.label("请填写密码"), delay: 1.2)
            return
        }
        if codeTF.text?.count == 0 {
            HUD.flash(.label("请填写验证码"), delay: 1.2)
            return
        }
        if codeNum == codeTF.text {
            //登录中状态
            loginBtn.isLoading = true
            login(["user_name":phoneTF.text as Any,"pwd":passTF.text as Any], success: { (data) in
                let dataM = data as! LoginModel
                UserDefaults.standard.set(dataM.data?.user_token, forKey: "user_token")
                UserDefaults.standard.synchronize()
                self.loginBtn.isLoading = false
                self.delegate?.successLogin()
            }) { (error) in
                self.loginBtn.isLoading = false
            }
        }else{
            HUD.flash(.label("请填写正确的验证码"), delay: 1.2)
        }

    }

    
}
