//
//  BluetoothConnectViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Dollar
class BluetoothConnectViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {

    

    @IBOutlet weak var bottomView: UIView!
    @IBOutlet weak var tableView: UITableView!
    let baby = BabyBluetooth.share()
    var peripheralDataArray : Array<CBPeripheral> = []
    var selectDataArray : Array<CBPeripheral> = []

    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "蓝牙打印设置"
        self.view.addSubview(navbar)
        // Do any additional setup after loading the view.
        tableView.separatorStyle = .none
   
        tableView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomView.snp_top)
        }
        tableView?.register(UINib(nibName: "BlueToothCell", bundle: nil), forCellReuseIdentifier: "BlueTooth")

        baby?.setBlockOnDiscoverToPeripherals({ (mangan, peripheral, adv, RSSI) in
            
        })
        
        baby?.setFilterOnDiscoverPeripherals({ (periName, adv, RSSI) -> Bool in
            if periName != nil {
                print("是否需要过滤\(periName)")
                return true
            }
            return false
        })
        baby?.setBlockOnDiscoverToPeripherals({ (central, peripheral, adv, RSSI) in
            print("搜索到的\(peripheral?.name)")
            if !self.peripheralDataArray.contains(peripheral!){
                self.peripheralDataArray.insert(peripheral!, at: 0)
                self.tableView.reloadData()
            }

        })
        baby?.scanForPeripherals()
        baby?.begin()
        
        //尝试链接
        baby?.setBlockOnConnected({ (central, peripheral) in
            print("设备\(peripheral?.name)连接成功")
            self.selectDataArray.removeAll()
            if self.peripheralDataArray.contains(peripheral!){
                Dollar.remove(self.peripheralDataArray, value: peripheral)
            }
            self.selectDataArray.insert(peripheral!, at: 0)
            self.tableView.reloadData()
            HUD.flash(.labeledSubSuccess(subtitle: "连接成功"),delay: 1.5)

        })
        baby?.setBlockOnFailToConnect({ (central, peripheral, error) in
            HUD.flash(.labeledSubError(subtitle: "连接失败"),delay: 1.5)

        })
 
        baby?.setBlockOnCancelAllPeripheralsConnectionBlock({ (cetral) in
            print("断开连接2223333")
            let currPeripheral:CBPeripheral = self.selectDataArray[0]
            self.peripheralDataArray.insert(currPeripheral, at: 0)
            self.selectDataArray.removeAll()
            self.tableView.reloadData()

        })
        
    }
    
    
    //MARK: -方法
    
    @IBAction func searchAction(_ sender: Any) {
        print("搜索")
        baby?.scanForPeripherals()
        baby?.begin()
    }
    //MARK: -Cell delegate
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 0 {
            print("准备取消所有连接11")
            self.baby?.cancelAllPeripheralsConnection()
            
        }else{
            HUD.show(.labeledProgress(title: "", subtitle: "连接中"))
            let currPeripheral:CBPeripheral = self.peripheralDataArray[indexPath.row]
            print("准备连接的设备：\(currPeripheral.name)")
            self.baby?.having(currPeripheral)?.and()?.channel("peripheralView")?.then()?.connectToPeripherals()?.begin()
        }

    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0{
            return self.selectDataArray.count
        }
        return self.peripheralDataArray.count
    }
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        switch section {
        case 0:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 46))
            view.backgroundColor = UIColor.init(named: "app底色")!
            let lbl = UILabel(frame: CGRect(x: 15, y: 0, width: self.view.bounds.size.width, height: 46))
            lbl.text = "已连接设备"
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            lbl.textColor = UIColor(named:"灰色字体颜色")
            view.addSubview(lbl)
            return view
        default:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 46))
            view.backgroundColor = UIColor.init(named: "app底色")!
            let lbl = UILabel(frame: CGRect(x: 15, y: 0, width: self.view.bounds.size.width, height: 46))
            lbl.text = "未连接设备"
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            lbl.textColor = UIColor(named:"灰色字体颜色")
            view.addSubview(lbl)
            return view
        }
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 46
    }
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        switch section {
        case 0:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 46))
            view.backgroundColor = UIColor.init(named: "app底色")!
            let lbl = UILabel(frame: CGRect(x: 15, y: 0, width: self.view.bounds.size.width, height: 46))
            lbl.text = "选择已经连接的设备作为默认打印设备"
            lbl.font = UIFont.boldSystemFont(ofSize: 11)
            lbl.textColor = UIColor(named:"灰色字体颜色")
            view.addSubview(lbl)
            return view
        default:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 46))
            view.backgroundColor = UIColor.init(named: "app底色")!
            let lbl = UILabel(frame: CGRect(x: 15, y: 0, width: self.view.bounds.size.width, height: 46))
            lbl.text = "选择设备进行连接"
            lbl.font = UIFont.boldSystemFont(ofSize: 11)
            lbl.textColor = UIColor(named:"灰色字体颜色")
            view.addSubview(lbl)
            return view
        }
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 46
    }
    //cell
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
   
        let cell = tableView.dequeueReusableCell(withIdentifier: "BlueTooth") as! BlueToothCell
        if indexPath.section == 0 {
            let currPeripheral:CBPeripheral = self.selectDataArray[indexPath.row]
            cell.contentLbl.text = currPeripheral.name
            cell.statusIcon.isHidden = false

        }else{
            cell.statusIcon.isHidden = true
            let currPeripheral:CBPeripheral = self.peripheralDataArray[indexPath.row]

            cell.contentLbl.text = currPeripheral.name
        }

        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }

    override func backAction() {
        print("重写back")
        self.navigationController?.popViewController(animated: true)
    }
}
