//
//  OrderDViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/21.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class OrderDViewController: BaseViewController {
    
    @IBOutlet weak var bottomView: UIView!
    
    @IBOutlet weak var scrollView: UIScrollView!
    
    var clientLbl:UILabel? //客户名称
    var statusLbl:UILabel? //订单状态：待付款
    
    //MARK: - 订单状态
    var djLbl:UILabel?//定金
    var wkLbl:UILabel?//尾款
    var sphjLbl:UILabel?//商品合计
    var wlfyLbl:UILabel?//物流费用
    var qtfyLbl:UILabel?//其他费用
    //MARK: - 订单信息
    var orderNumLbl:UILabel?//订单编号
    var orderTimeLbl:UILabel?//下单时间
    var orderSourceLbl:UILabel?//订单来源
    var yunDanHaoTF:UITextField?//输入运单号
    var wuLiuGongSiTF:UITextField?//请输入物流公司
    var payTypeLbl:UILabel?//支付方式
    var payStatusLbl:UILabel?//支付状态
    var contentLbl:UILabel?//买家留言
    var dingDanBeiZhuTF:UITextField?//请输入留言信息

    //MARK: - 收货信息
    var receiverLbl:UILabel?//收货人
    var phoneNumLbl:UILabel?//手机号码
    var addressLbl:UILabel?//地址
    var totalPriceLbl:UILabel?//总费用
    
    var firstImg:UIImageView?//第1个商品图片
    var firstItemLbl:UILabel?//第1个商品名称
    var firstDetailLbl:UILabel?//第1个商品详情
    var firstPriceLbl:UILabel?//第1个商品价格
    
    var secondImg:UIImageView?//第2个商品图片
    var secondItemLbl:UILabel?//第2个商品名称
    var secondDetailLbl:UILabel?//第2个商品详情
    var secondPriceLbl:UILabel?//第2个商品价格
    
    //是否预售
    var isBooking:Bool = false
    //测试数据
    var listArray = ["a","b","c"]
    let btmBtnTitleArray = ["修改价格","打印","确认订单","取消订单"]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "订单详情"
        self.view.addSubview(navbar)
        self.setBottomBtn(sender: bottomView)
        scrollView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(bottomView.snp_top)
        }
        
        let partFirst = self.setPartFirst()
        let partSecond = self.setPartSecond(partFirst: partFirst)
        let partThird = self.setPartThird(partSecond: partSecond)
        self.setPartForth(partThird: partThird)
        
        //是否预售。
//        isBooking 仅会出现一个商品
//        listArray.count 根据数量判断显示
        // Do any additional setup after loading the view.
    }
    //MARK: - 详情第四栏
    func setPartForth(partThird:UIView){
        let partForth = UIView()
        partForth.backgroundColor = UIColor.white
        scrollView.addSubview(partForth)
        partForth.snp.makeConstraints { (make) in
            make.top.equalTo(partThird.snp_bottom).offset(10)
            make.left.equalTo(0)
            make.width.equalTo(fullScreenWidth)
            make.height.equalTo(485)
            make.bottom.equalTo(scrollView.snp_bottom)//scrollview滚动必要代码
        }

 
        let title = UILabel()
        partForth.addSubview(title)
        title.text = "订单信息"
        title.font = UIFont.systemFont(ofSize: 15)
        title.textColor = UIColor(named: "标题字颜色")
        title.snp.makeConstraints { (make) in
            make.top.right.equalTo(15)
            make.left.equalTo(15)
            make.height.equalTo(21)
        }
        
        let t1 = UILabel()
        partForth.addSubview(t1)
        t1.text = "订单编号："
        t1.font = UIFont.systemFont(ofSize: 13)
        t1.textColor = UIColor(named: "标题字颜色")
        t1.snp.makeConstraints { (make) in
            make.top.equalTo(title.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c1 = UILabel()
        partForth.addSubview(c1)
        orderNumLbl = c1
        c1.text = "5546541211221121"
        c1.textAlignment = .right
        c1.font = UIFont.systemFont(ofSize: 13)
        c1.textColor = UIColor(named: "标题字颜色")
        c1.snp.makeConstraints { (make) in
            make.centerY.equalTo(t1.snp_centerY)
            make.left.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        
        let l1 = UIView()
        partForth.addSubview(l1)
        l1.backgroundColor = UIColor(named: "灰色分界线")
        l1.snp.makeConstraints { (make) in
            make.top.equalTo(c1.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t2 = UILabel()
        partForth.addSubview(t2)
        t2.text = "下单时间："
        t2.font = UIFont.systemFont(ofSize: 13)
        t2.textColor = UIColor(named: "标题字颜色")
        t2.snp.makeConstraints { (make) in
            make.top.equalTo(l1.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c2 = UILabel()
        partForth.addSubview(c2)
        orderTimeLbl = c2
        c2.text = "2020.04.25 14:16:32"
        c2.textAlignment = .right
        c2.font = UIFont.systemFont(ofSize: 13)
        c2.textColor = UIColor(named: "标题字颜色")
        c2.snp.makeConstraints { (make) in
            make.centerY.equalTo(t2.snp_centerY)
            make.left.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        
        let l2 = UIView()
        partForth.addSubview(l2)
        l2.backgroundColor = UIColor(named: "灰色分界线")
        l2.snp.makeConstraints { (make) in
            make.top.equalTo(c2.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t3 = UILabel()
        partForth.addSubview(t3)
        t3.text = "订单来源："
        t3.font = UIFont.systemFont(ofSize: 13)
        t3.textColor = UIColor(named: "标题字颜色")
        t3.snp.makeConstraints { (make) in
            make.top.equalTo(l2.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c3 = UILabel()
        partForth.addSubview(c3)
        orderSourceLbl = c3
        c3.text = "小程序"
        c3.textAlignment = .right
        c3.font = UIFont.systemFont(ofSize: 13)
        c3.textColor = UIColor(named: "标题字颜色")
        c3.snp.makeConstraints { (make) in
            make.centerY.equalTo(t3.snp_centerY)
            make.left.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        
        let l3 = UIView()
        partForth.addSubview(l3)
        l3.backgroundColor = UIColor(named: "灰色分界线")
        l3.snp.makeConstraints { (make) in
            make.top.equalTo(c3.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t4 = UILabel()
        partForth.addSubview(t4)
        t4.text = "运单号"
        t4.font = UIFont.systemFont(ofSize: 13)
        t4.textColor = UIColor(named: "标题字颜色")
        t4.snp.makeConstraints { (make) in
            make.top.equalTo(l3.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let yunDanHaoTF = UITextField()
        yunDanHaoTF.textAlignment = .right
        yunDanHaoTF.textColor = UIColor(named: "标题字颜色")
        yunDanHaoTF.placeholder = "请输入物流单号"
        yunDanHaoTF.borderStyle = .none
        yunDanHaoTF.addTarget(self, action: #selector(inputAction(sender:)), for: .allEditingEvents)
        yunDanHaoTF.font = UIFont.systemFont(ofSize: 13)
        partForth.addSubview(yunDanHaoTF)
        self.yunDanHaoTF = yunDanHaoTF
        yunDanHaoTF.snp.makeConstraints { (make) in
            make.right.equalTo(-41.5)
            make.centerY.equalTo(t4.snp_centerY)
            make.height.equalTo(47)
        }
        
        let img1 = UIImageView()
        img1.image = UIImage(named: "bianji")
        partForth.addSubview(img1)
        img1.snp.makeConstraints { (make) in
            make.right.equalTo(-14)
            make.centerY.equalTo(t4.snp_centerY)
            make.height.equalTo(17)
            make.width.equalTo(17.5)
        }
        
        let l4 = UIView()
        partForth.addSubview(l4)
        l4.backgroundColor = UIColor(named: "灰色分界线")
        l4.snp.makeConstraints { (make) in
            make.top.equalTo(yunDanHaoTF.snp_bottom)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t5 = UILabel()
        partForth.addSubview(t5)
        t5.text = "物流公司"
        t5.font = UIFont.systemFont(ofSize: 13)
        t5.textColor = UIColor(named: "标题字颜色")
        t5.snp.makeConstraints { (make) in
            make.top.equalTo(l4.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let wuLiuGongSiTF = UITextField()
        wuLiuGongSiTF.textAlignment = .right
        wuLiuGongSiTF.textColor = UIColor(named: "标题字颜色")
        wuLiuGongSiTF.placeholder = "请输入物流公司"
        wuLiuGongSiTF.borderStyle = .none
        wuLiuGongSiTF.addTarget(self, action: #selector(inputAction(sender:)), for: .allEditingEvents)
        wuLiuGongSiTF.font = UIFont.systemFont(ofSize: 13)
        partForth.addSubview(wuLiuGongSiTF)
        self.wuLiuGongSiTF = wuLiuGongSiTF
        wuLiuGongSiTF.snp.makeConstraints { (make) in
            make.right.equalTo(-41.5)
            make.centerY.equalTo(t5.snp_centerY)
            make.height.equalTo(47)
        }
        
        let img2 = UIImageView()
        img2.image = UIImage(named: "bianji")
        partForth.addSubview(img2)
        img2.snp.makeConstraints { (make) in
            make.right.equalTo(-14)
            make.centerY.equalTo(t5.snp_centerY)
            make.height.equalTo(17)
            make.width.equalTo(17.5)
        }
        
        let l5 = UIView()
        partForth.addSubview(l5)
        l5.backgroundColor = UIColor(named: "灰色分界线")
        l5.snp.makeConstraints { (make) in
            make.top.equalTo(wuLiuGongSiTF.snp_bottom)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t6 = UILabel()
        partForth.addSubview(t6)
        t6.text = "支付方式"
        t6.font = UIFont.systemFont(ofSize: 13)
        t6.textColor = UIColor(named: "标题字颜色")
        t6.snp.makeConstraints { (make) in
            make.top.equalTo(l5.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c4 = UILabel()
        c4.textAlignment = .right
        c4.textColor = UIColor(named: "灰色字体颜色")
        c4.text = "未支付"
        c4.font = UIFont.systemFont(ofSize: 13)
        partForth.addSubview(c4)
        payTypeLbl = c4
        c4.snp.makeConstraints { (make) in
            make.left.right.equalTo(-32)
            make.centerY.equalTo(t6.snp_centerY)
            make.height.equalTo(18.5)
        }
        
        let img3 = UIImageView()
        img3.image = UIImage(named: "jinruDetail")
        partForth.addSubview(img3)
        img3.snp.makeConstraints { (make) in
            make.right.equalTo(-14)
            make.centerY.equalTo(t6.snp_centerY)
            make.height.equalTo(9)
            make.width.equalTo(5)
        }
        
        let btn1 = UIButton()
        partForth.addSubview(btn1)
        btn1.addTarget(self, action: #selector(btnClickAction(sender:)), for: .touchUpInside)
        btn1.tag = 0
        btn1.snp.makeConstraints { (make) in
            make.centerY.equalTo(img3.snp_centerY)
            make.left.equalTo(c4.snp.right)
            make.height.width.equalTo(47)
        }
        
        let l6 = UIView()
        partForth.addSubview(l6)
        l6.backgroundColor = UIColor(named: "灰色分界线")
        l6.snp.makeConstraints { (make) in
            make.top.equalTo(btn1.snp_bottom)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t7 = UILabel()
        partForth.addSubview(t7)
        t7.text = "支付状态"
        t7.font = UIFont.systemFont(ofSize: 13)
        t7.textColor = UIColor(named: "标题字颜色")
        t7.snp.makeConstraints { (make) in
            make.top.equalTo(l6.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c5 = UILabel()
        c5.textAlignment = .right
        c5.textColor = UIColor(named: "灰色字体颜色")
        c5.text = "未付款"
        c5.font = UIFont.systemFont(ofSize: 13)
        partForth.addSubview(c5)
        payStatusLbl = c5
        c5.snp.makeConstraints { (make) in
            make.left.right.equalTo(-32)
            make.centerY.equalTo(t7.snp_centerY)
            make.height.equalTo(18.5)
        }
        
        let img4 = UIImageView()
        img4.image = UIImage(named: "jinruDetail")
        partForth.addSubview(img4)
        img4.snp.makeConstraints { (make) in
            make.right.equalTo(-14)
            make.centerY.equalTo(t7.snp_centerY)
            make.height.equalTo(9)
            make.width.equalTo(5)
        }
        
        let btn2 = UIButton()
        partForth.addSubview(btn2)
        btn2.addTarget(self, action: #selector(btnClickAction(sender:)), for: .touchUpInside)
        btn2.tag = 1
        btn2.snp.makeConstraints { (make) in
            make.centerY.equalTo(img4.snp_centerY)
            make.left.equalTo(c5.snp.right)
            make.height.width.equalTo(47)
        }
        
        let l7 = UIView()
        partForth.addSubview(l7)
        l7.backgroundColor = UIColor(named: "灰色分界线")
        l7.snp.makeConstraints { (make) in
            make.top.equalTo(btn2.snp_bottom)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t8 = UILabel()
        partForth.addSubview(t8)
        t8.text = "买家留言"
        t8.font = UIFont.systemFont(ofSize: 13)
        t8.textColor = UIColor(named: "标题字颜色")
        t8.snp.makeConstraints { (make) in
            make.top.equalTo(l7.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let c6 = UILabel()
        c6.numberOfLines = 0
        partForth.addSubview(c6)
        c6.text = "轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢轻拿轻放，谢谢"
        c6.textAlignment = .right
        c6.font = UIFont.systemFont(ofSize: 13)
        c6.textColor = UIColor(named: "标题字颜色")
        c6.snp.makeConstraints { (make) in
            make.top.equalTo(l7.snp_bottom).offset(3)
            make.right.equalTo(-15)
            make.height.equalTo(45)
            make.width.equalTo(fullScreenWidth*0.5)
        }
        contentLbl = c6
        
        let l8 = UIView()
        partForth.addSubview(l8)
        l8.backgroundColor = UIColor(named: "灰色分界线")
        l8.snp.makeConstraints { (make) in
            make.top.equalTo(c6.snp_bottom).offset(3)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t9 = UILabel()
        partForth.addSubview(t9)
        t9.text = "物流公司"
        t9.font = UIFont.systemFont(ofSize: 13)
        t9.textColor = UIColor(named: "标题字颜色")
        t9.snp.makeConstraints { (make) in
            make.top.equalTo(l8.snp_bottom).offset(15)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let dingDanBeiZhuTF = UITextField()
        dingDanBeiZhuTF.textAlignment = .right
        dingDanBeiZhuTF.textColor = UIColor(named: "标题字颜色")
        dingDanBeiZhuTF.placeholder = "请输入留言信息"
        dingDanBeiZhuTF.borderStyle = .none
        dingDanBeiZhuTF.addTarget(self, action: #selector(inputAction(sender:)), for: .allEditingEvents)
        dingDanBeiZhuTF.font = UIFont.systemFont(ofSize: 13)
        partForth.addSubview(dingDanBeiZhuTF)
        self.dingDanBeiZhuTF = dingDanBeiZhuTF
        dingDanBeiZhuTF.snp.makeConstraints { (make) in
            make.right.equalTo(-41.5)
            make.centerY.equalTo(t9.snp_centerY)
            make.height.equalTo(47)
        }
        
        let img5 = UIImageView()
        img5.image = UIImage(named: "bianji")
        partForth.addSubview(img5)
        img5.snp.makeConstraints { (make) in
            make.right.equalTo(-14)
            make.centerY.equalTo(t9.snp_centerY)
            make.height.equalTo(17)
            make.width.equalTo(17.5)
        }
    }
    @objc func btnClickAction(sender:UIButton){
        print(sender.tag)
    }
    //MARK: -运单号、物流公司、订单备注（输入方法）
    @objc func inputAction(sender:UITextField){
        print(sender.text)
    }
    //MARK: -详情第三栏
    func setPartThird(partSecond:UIView)->UIView{
        let partThird = UIView()
        partThird.backgroundColor = UIColor.white
        scrollView.addSubview(partThird)
        partThird.snp.makeConstraints { (make) in
            make.top.equalTo(partSecond.snp_bottom).offset(20)
            make.left.equalTo(0)
            make.width.equalTo(fullScreenWidth)
            make.height.equalTo(185)
        }
        let title = UILabel()
        partThird.addSubview(title)
        title.text = "收货信息"
        title.font = UIFont.systemFont(ofSize: 15)
        title.textColor = UIColor(named: "标题字颜色")
        title.snp.makeConstraints { (make) in
            make.top.right.equalTo(15)
            make.left.equalTo(15)
            make.height.equalTo(21)
        }
        
        let t1 = UILabel()
        partThird.addSubview(t1)
        t1.text = "收货人"
        t1.font = UIFont.systemFont(ofSize: 13)
        t1.textColor = UIColor(named: "标题字颜色")
        t1.snp.makeConstraints { (make) in
            make.top.equalTo(title.snp_bottom).offset(19)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let receiver = UILabel()
        partThird.addSubview(receiver)
        receiver.textAlignment = .right
        receiver.text = "梁小锋"
        receiver.font = UIFont.systemFont(ofSize: 13)
        receiver.textColor = UIColor(named: "标题字颜色")
        receiver.snp.makeConstraints { (make) in
            make.top.equalTo(title.snp_bottom).offset(21)
            make.left.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        receiverLbl = receiver
        
        let l1 = UIView()
        partThird.addSubview(l1)
        l1.backgroundColor = UIColor(named: "灰色分界线")
        l1.snp.makeConstraints { (make) in
            make.top.equalTo(receiver.snp_bottom).offset(14)
            make.left.right.equalTo(15)
            make.height.equalTo(1)
        }
        
        
        let t2 = UILabel()
        partThird.addSubview(t2)
        t2.text = "联系电话"
        t2.font = UIFont.systemFont(ofSize: 13)
        t2.textColor = UIColor(named: "标题字颜色")
        t2.snp.makeConstraints { (make) in
            make.top.equalTo(l1.snp_bottom).offset(14)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let phoneL = UILabel()
        partThird.addSubview(phoneL)
        phoneL.textAlignment = .right
        phoneL.text = "15577124121"
        phoneL.font = UIFont.systemFont(ofSize: 13)
        phoneL.textColor = UIColor(named: "标题字颜色")
        phoneL.snp.makeConstraints { (make) in
            make.centerY.equalTo(t2.snp_centerY)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        phoneNumLbl = phoneL
        
        let l2 = UIView()
        partThird.addSubview(l2)
        l2.backgroundColor = UIColor(named: "灰色分界线")
        l2.snp.makeConstraints { (make) in
            make.top.equalTo(phoneL.snp_bottom).offset(14)
            make.left.right.equalTo(15)
            make.height.equalTo(1)
        }
        
        let t3 = UILabel()
        partThird.addSubview(t3)
        t3.text = "地址"
        t3.font = UIFont.systemFont(ofSize: 13)
        t3.textColor = UIColor(named: "标题字颜色")
        t3.snp.makeConstraints { (make) in
            make.top.equalTo(l2.snp_bottom).offset(14)
            make.left.right.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let addressL = UILabel()
        partThird.addSubview(addressL)
        addressL.textAlignment = .right
        addressL.text = "广东省广州市荔湾区福利大厦2105号"
        addressL.font = UIFont.systemFont(ofSize: 13)
        addressL.textColor = UIColor(named: "标题字颜色")
        addressL.snp.makeConstraints { (make) in
            make.centerY.equalTo(t3.snp_centerY)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(18.5)
        }
        addressLbl = addressL
        return partThird
    }
    //MARK: -详情第二栏
    func setPartSecond(partFirst:UIView)->UIView{
        let partSecond = UIView()
        partSecond.backgroundColor = UIColor.white
        scrollView.addSubview(partSecond)
        partSecond.snp.makeConstraints { (make) in
            make.top.equalTo(partFirst.snp_bottom).offset(10)
            make.left.equalTo(0)
            make.width.equalTo(fullScreenWidth)
            make.height.equalTo(524.5)
            //            make.bottom.equalTo(scrollView.snp_bottom)//scrollview滚动必要代码
        }
        let title = UILabel()
        partSecond.addSubview(title)
        title.font = UIFont.systemFont(ofSize: 13)
        title.textColor = UIColor(named: "标题字颜色")
        title.text = "订单状态"
        title.snp.makeConstraints { (make) in
            make.top.right.equalTo(0)
            make.left.equalTo(15)
            make.height.equalTo(48)
        }
        
        let status = UILabel()
        partSecond.addSubview(status)
        status.font = UIFont.systemFont(ofSize: 13)
        status.textAlignment = .right
        status.textColor = UIColor(named: "按钮渐变色下,字体颜色")
        status.text = "待付款"
        status.snp.makeConstraints { (make) in
            make.right.equalTo(-15)
            make.top.left.equalTo(0)
            make.height.equalTo(48)
        }
        statusLbl = status
        
        let line = UIView()
        line.backgroundColor = UIColor(named: "灰色分界线")
        partSecond.addSubview(line)
        line.snp.makeConstraints { (make) in
            make.top.equalTo(status.snp_bottom)
            make.left.right.equalTo(0)
            make.height.equalTo(1)
        }
        
        
        let viewT = UIView()
        partSecond.addSubview(viewT)
        viewT.snp.makeConstraints { (make) in
            make.top.equalTo(line.snp_bottom)
            make.left.right.equalTo(0)
            make.height.equalTo(120)
        }
        let imgFirst = UIImageView()
        imgFirst.layer.cornerRadius = 3
        imgFirst.layer.masksToBounds = true
        imgFirst.layer.borderWidth = 1
        imgFirst.layer.borderColor = UIColor(named: "灰色分界线")?.cgColor
        viewT.addSubview(imgFirst)
        imgFirst.snp.makeConstraints { (make) in
            make.left.top.equalTo(15)
            make.width.height.equalTo(90)
        }
        firstImg = imgFirst
        
        let firTitLbl = UILabel()
        viewT.addSubview(firTitLbl)
        let paraph = NSMutableParagraphStyle()
        paraph.lineSpacing = 4
        let attributes = [NSAttributedString.Key.font:UIFont.systemFont(ofSize: 15),
                          NSAttributedString.Key.paragraphStyle: paraph]
        firTitLbl.attributedText = NSAttributedString(string: "六和川香鸡柳2.5kg/新疆和六和川香鸡柳2.5kg/新疆和", attributes: attributes)
        firTitLbl.font = UIFont.systemFont(ofSize: 13)
        firTitLbl.textColor = UIColor(named: "标题字颜色")
        firTitLbl.numberOfLines = 0
        firstItemLbl = firTitLbl
        let size = self.getStringSize(str: firTitLbl.attributedText!)
        firTitLbl.snp.makeConstraints { (make) in
            make.top.equalTo(15)
            make.left.equalTo(imgFirst.snp_right).offset(10)
            make.right.equalTo(-24.5)
            make.height.equalTo(size.height+2)
        }
        
        let firDetailLbl = UILabel()
        firDetailLbl.font = UIFont.systemFont(ofSize: 11)
        firDetailLbl.textColor = UIColor(named: "灰色字体颜色")
        firDetailLbl.text = "5kg/箱/袋"
        firstDetailLbl = firDetailLbl
        viewT.addSubview(firDetailLbl)
        firDetailLbl.snp.makeConstraints { (make) in
            make.left.equalTo(imgFirst.snp_right).offset(10)
            make.top.equalTo(firTitLbl.snp_bottom).offset(15)
            make.height.equalTo(15)
            make.right.equalTo(-15)
        }
        
        let firPriceLbl = UILabel()
        viewT.addSubview(firPriceLbl)
        firPriceLbl.text = "¥40.00"
        firPriceLbl.textAlignment = .right
        firPriceLbl.font = UIFont.systemFont(ofSize: 13)
        firPriceLbl.textColor = UIColor(named: "标题字颜色")
        firstPriceLbl = firPriceLbl
        firPriceLbl.snp.makeConstraints { (make) in
            make.bottom.equalTo(imgFirst.snp_bottom)
            make.right.equalTo(-15)
            make.left.equalTo(10)
            make.height.equalTo(18.5)
        }
        
        let lineF = UIView()
        viewT.addSubview(lineF)
        lineF.backgroundColor = UIColor(named: "灰色分界线")
        lineF.snp.makeConstraints { (make) in
            make.top.equalTo(firPriceLbl.snp_bottom).offset(14.5)
            make.left.right.equalTo(0)
            make.height.equalTo(1)
        }
        if isBooking {//预售
            let bookImg = UIImageView()
            imgFirst.addSubview(bookImg)
            bookImg.image = UIImage(named: "yushou")
            bookImg.snp.makeConstraints { (make) in
                make.top.right.equalTo(0)
                make.height.equalTo(18)
                make.width.equalTo(34)
            }
            
            let t1 = UILabel()
            viewT.addSubview(t1)
            t1.text = "定金："
            t1.font = UIFont.systemFont(ofSize: 13)
            t1.textColor = UIColor(named: "标题字颜色")
            t1.snp.makeConstraints { (make) in
                make.top.equalTo(lineF.snp_bottom).offset(15)
                make.left.equalTo(15)
                make.height.equalTo(18.5)
                make.width.equalTo(100)
            }
            
            let dingJinLbl = UILabel()
            viewT.addSubview(dingJinLbl)
            dingJinLbl.text = "(已付) ¥2000.00"
            dingJinLbl.font = UIFont.systemFont(ofSize: 13)
            dingJinLbl.textAlignment = .right
            dingJinLbl.textColor = UIColor(named: "标题字颜色")
            djLbl = dingJinLbl
            dingJinLbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(t1.snp_centerY)
                make.right.equalTo(-15)
                make.left.equalTo(15)
                make.height.equalTo(18.5)
            }
            
            let l1 = UIView()
            viewT.addSubview(l1)
            l1.backgroundColor = UIColor(named: "灰色分界线")
            l1.snp.makeConstraints { (make) in
                make.top.equalTo(dingJinLbl.snp_bottom).offset(15.5)
                make.left.right.equalTo(15)
                make.height.equalTo(1)
            }
            
            
            let t2 = UILabel()
            viewT.addSubview(t2)
            t2.text = "尾款："
            t2.font = UIFont.systemFont(ofSize: 13)
            t2.textColor = UIColor(named: "标题字颜色")
            t2.snp.makeConstraints { (make) in
                make.top.equalTo(l1.snp_bottom).offset(15)
                make.left.equalTo(15)
                make.height.equalTo(18.5)
                make.width.equalTo(100)
            }
            
            let weiKuanLbl = UILabel()
            viewT.addSubview(weiKuanLbl)
            weiKuanLbl.text = "¥9052.00"
            weiKuanLbl.font = UIFont.systemFont(ofSize: 13)
            weiKuanLbl.textAlignment = .right
            weiKuanLbl.textColor = UIColor(named: "标题字颜色")
            wkLbl = weiKuanLbl
            weiKuanLbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(t2.snp_centerY)
                make.right.equalTo(-15)
                make.left.equalTo(15)
                make.height.equalTo(18.5)
            }
            
            let l2 = UIView()
            viewT.addSubview(l2)
            l2.backgroundColor = UIColor(named: "灰色分界线")
            l2.snp.makeConstraints { (make) in
                make.top.equalTo(weiKuanLbl.snp_bottom).offset(15.5)
                make.left.right.equalTo(15)
                make.height.equalTo(1)
            }
            viewT.snp.updateConstraints { (make) in
                make.top.equalTo(line.snp_bottom)
                make.left.right.equalTo(0)
                make.height.equalTo(220)
            }
            
        }else{//非预售
            if listArray.count >= 2 {//刚好2个
                let imgSecond = UIImageView()
                imgSecond.layer.cornerRadius = 3
                imgSecond.layer.masksToBounds = true
                imgSecond.layer.borderWidth = 1
                imgSecond.layer.borderColor = UIColor(named: "灰色分界线")?.cgColor
                viewT.addSubview(imgSecond)
                imgSecond.snp.makeConstraints { (make) in
                    make.top.equalTo(lineF.snp_bottom).offset(15)
                    make.left.equalTo(15)
                    make.width.height.equalTo(90)
                }
                secondImg = imgSecond
                
                let secTitLbl = UILabel()
                viewT.addSubview(secTitLbl)
                secTitLbl.attributedText = NSAttributedString(string: "六和川香鸡柳2.5kg/新疆和六和川香鸡柳2.5kg/新疆和", attributes: attributes)
                secTitLbl.font = UIFont.systemFont(ofSize: 13)
                secTitLbl.textColor = UIColor(named: "标题字颜色")
                secTitLbl.numberOfLines = 0
                secondItemLbl = secTitLbl
                let size = self.getStringSize(str: secTitLbl.attributedText!)
                secTitLbl.snp.makeConstraints { (make) in
                    make.top.equalTo(lineF.snp_bottom).offset(15)
                    make.left.equalTo(imgSecond.snp_right).offset(10)
                    make.right.equalTo(-24.5)
                    make.height.equalTo(size.height+2)
                }
                
                let secDetailLbl = UILabel()
                secDetailLbl.font = UIFont.systemFont(ofSize: 11)
                secDetailLbl.textColor = UIColor(named: "灰色字体颜色")
                secDetailLbl.text = "5kg/箱/袋"
                secondDetailLbl = secDetailLbl
                viewT.addSubview(secDetailLbl)
                
                secDetailLbl.snp.makeConstraints { (make) in
                    make.left.equalTo(imgSecond.snp_right).offset(10)
                    make.top.equalTo(secTitLbl.snp_bottom).offset(15)
                    make.height.equalTo(15)
                    make.right.equalTo(-15)
                }
                
                let secPriceLbl = UILabel()
                viewT.addSubview(secPriceLbl)
                secPriceLbl.text = "¥40.00"
                secPriceLbl.textAlignment = .right
                secPriceLbl.font = UIFont.systemFont(ofSize: 13)
                secPriceLbl.textColor = UIColor(named: "标题字颜色")
                secondPriceLbl = secPriceLbl
                secPriceLbl.snp.makeConstraints { (make) in
                    make.bottom.equalTo(imgSecond.snp_bottom)
                    make.right.equalTo(-15)
                    make.left.equalTo(10)
                    make.height.equalTo(18.5)
                }
                viewT.snp.updateConstraints { (make) in
                    make.top.equalTo(line.snp_bottom)
                    make.left.right.equalTo(0)
                    make.height.equalTo(240)
                }
                if listArray.count > 2 {
                    let btn = UIButton()
                    viewT.addSubview(btn)
                    btn.setTitle("查看全部（共\(listArray.count)个商品）", for: .normal)
                    btn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
                    btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                    btn.addTarget(self, action: #selector(showDetailList), for: .touchUpInside)
                    btn.snp.makeConstraints { (make) in
                        make.top.equalTo(imgSecond.snp_bottom).offset(15)
                        make.right.left.equalTo(0)
                        make.height.equalTo(34.5)
                    }
                    viewT.snp.updateConstraints { (make) in
                        make.top.equalTo(line.snp_bottom)
                        make.left.right.equalTo(0)
                        make.height.equalTo(274.5)
                    }
                }
            }
        }
        
        
        let t1 = UILabel()
        partSecond.addSubview(t1)
        t1.text = "商品合计"
        t1.font = UIFont.systemFont(ofSize: 13)
        t1.textColor = UIColor(named: "标题字颜色")
        t1.snp.makeConstraints { (make) in
            make.top.equalTo(viewT.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
            make.width.equalTo(100)
        }
        
        let sphjLbl = UILabel()
        partSecond.addSubview(sphjLbl)
        sphjLbl.text = "¥6251.00"
        sphjLbl.font = UIFont.systemFont(ofSize: 13)
        sphjLbl.textAlignment = .right
        sphjLbl.textColor = UIColor(named: "标题字颜色")
        self.sphjLbl = sphjLbl
        sphjLbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(t1.snp_centerY)
            make.right.equalTo(-15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let l1 = UIView()
        partSecond.addSubview(l1)
        l1.backgroundColor = UIColor(named: "灰色分界线")
        l1.snp.makeConstraints { (make) in
            make.top.equalTo(sphjLbl.snp_bottom).offset(15.5)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        
        let t2 = UILabel()
        partSecond.addSubview(t2)
        t2.text = "物流费用"
        t2.font = UIFont.systemFont(ofSize: 13)
        t2.textColor = UIColor(named: "标题字颜色")
        t2.snp.makeConstraints { (make) in
            make.top.equalTo(l1.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
            make.width.equalTo(100)
        }
        
        let wlfyLbl = UILabel()
        partSecond.addSubview(wlfyLbl)
        wlfyLbl.text = "¥651.00"
        wlfyLbl.font = UIFont.systemFont(ofSize: 13)
        wlfyLbl.textAlignment = .right
        wlfyLbl.textColor = UIColor(named: "标题字颜色")
        self.wlfyLbl = wlfyLbl
        wlfyLbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(t2.snp_centerY)
            make.right.equalTo(-15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let l2 = UIView()
        partSecond.addSubview(l2)
        l2.backgroundColor = UIColor(named: "灰色分界线")
        l2.snp.makeConstraints { (make) in
            make.top.equalTo(wlfyLbl.snp_bottom).offset(15.5)
            make.left.equalTo(15)
            make.height.right.equalTo(1)
        }
        
        let t3 = UILabel()
        partSecond.addSubview(t3)
        t3.text = "其他费用"
        t3.font = UIFont.systemFont(ofSize: 13)
        t3.textColor = UIColor(named: "标题字颜色")
        t3.snp.makeConstraints { (make) in
            make.top.equalTo(l2.snp_bottom).offset(15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
            make.width.equalTo(100)
        }
        
        let qtfyLbl = UILabel()
        partSecond.addSubview(qtfyLbl)
        qtfyLbl.text = "¥400.50"
        qtfyLbl.font = UIFont.systemFont(ofSize: 13)
        qtfyLbl.textAlignment = .right
        qtfyLbl.textColor = UIColor(named: "标题字颜色")
        self.qtfyLbl = qtfyLbl
        qtfyLbl.snp.makeConstraints { (make) in
            make.centerY.equalTo(t3.snp_centerY)
            make.right.equalTo(-15)
            make.left.equalTo(15)
            make.height.equalTo(18.5)
        }
        
        let l3 = UIView()
        partSecond.addSubview(l3)
        l3.backgroundColor = UIColor(named: "灰色分界线")
        l3.snp.makeConstraints { (make) in
            make.top.equalTo(qtfyLbl.snp_bottom).offset(15.5)
            make.left.right.equalTo(0)
            make.height.equalTo(1)
        }
        
        let bView = UIView()
        partSecond.addSubview(bView)
        bView.snp.makeConstraints { (make) in
            make.height.equalTo(49)
            make.left.right.equalTo(0)
            make.top.equalTo(l3.snp_bottom)
        }
        
        let totalPLbl = UILabel()
        bView.addSubview(totalPLbl)
        totalPriceLbl = totalPLbl
        totalPLbl.text = "¥814234.00"
        totalPLbl.font = UIFont.systemFont(ofSize: 13)
        totalPLbl.textAlignment = .right
        totalPLbl.textColor = UIColor(named: "按钮渐变色下,字体颜色")
        self.wlfyLbl = totalPLbl
        totalPLbl.sizeToFit()
        totalPLbl.snp.makeConstraints { (make) in
            make.right.equalTo(-15)
            make.width.equalTo(totalPLbl.frame.size.width)
            make.bottom.top.equalTo(0)
        }
        let t99 = UILabel()
        bView.addSubview(t99)
        t99.text = "订单合计："
        t99.font = UIFont.systemFont(ofSize: 13)
        t99.textAlignment = .right
        t99.textColor = UIColor(named: "标题字颜色")
        t99.snp.makeConstraints { (make) in
            make.right.equalTo(totalPLbl.snp_left)
            make.left.equalTo(0)
            make.bottom.top.equalTo(0)
        }
        var totalH = 0.0
        if isBooking {
            totalH = 470
        }else{
            if listArray.count >= 2 {
                totalH = 490
                if listArray.count > 2 {
                    totalH = 524.5
                }
            }else{
                totalH = 371
            }
        }
        partSecond.snp.updateConstraints { (make) in
            make.top.equalTo(partFirst.snp_bottom).offset(10)
            make.left.equalTo(0)
            make.width.equalTo(fullScreenWidth)
            make.height.equalTo(totalH)
        }
        return partSecond
    }
    //MARK: -详情第一栏
    func setPartFirst()->UIView{
        let partFirst = UIView()
        partFirst.backgroundColor = UIColor.white
        scrollView.addSubview(partFirst)
        partFirst.snp.makeConstraints { (make) in
            make.top.equalTo(10)
            make.left.equalTo(0)
            make.width.equalTo(fullScreenWidth)
            make.height.equalTo(49)
        }
        let title = UILabel()
        partFirst.addSubview(title)
        title.font = UIFont.systemFont(ofSize: 13)
        title.textColor = UIColor(named: "标题字颜色")
        title.text = "关联客户"
        title.snp.makeConstraints { (make) in
            make.top.bottom.right.equalTo(0)
            make.left.equalTo(15)
        }
        
        let img = UIImageView()
        img.image = UIImage(named: "jinruDetail")
        partFirst.addSubview(img)
        img.snp.makeConstraints { (make) in
            make.width.equalTo(6)
            make.height.equalTo(9)
            make.centerY.equalTo(partFirst.snp_centerY)
            make.right.equalTo(-15)
        }
        
        let detail = UILabel()
        partFirst.addSubview(detail)
        detail.font = UIFont.systemFont(ofSize: 13)
        detail.textColor = UIColor(named: "灰色字体颜色")
        detail.text = "请选择关联客户"
        detail.textAlignment = .right
        detail.snp.makeConstraints { (make) in
            make.top.bottom.equalTo(0)
            make.left.equalTo(15)
            make.right.equalTo(img.snp_left).offset(-9)
        }
        clientLbl = detail
        
        let btn = UIButton()
        partFirst.addSubview(btn)
        btn.addTarget(self, action: #selector(selectClint), for: .touchUpInside)
        btn.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalTo(0)
        }
        return partFirst
    }
    //底栏按钮
    func setBottomBtn(sender:UIView){
        
        let x = fullScreenWidth / CGFloat(btmBtnTitleArray.count)
        for index in 0 ..< btmBtnTitleArray.count {
            let btn = UIButton(frame: CGRect(x: CGFloat(index) * x, y: 0, width: x, height: 49))
            btn.tag = index
            btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            btn.setTitle(btmBtnTitleArray[index], for: .normal)
            btn.setTitleColor(UIColor(named: "按钮渐变色下,字体颜色"), for: .normal)
            btn.addTarget(self, action: #selector(bottomButtonClickAction(sender:)), for: .touchUpInside)
            sender.addSubview(btn)
        }
    }
    //MARK:--跳转关联客户选择
    @objc func selectClint(){
        print("selectClint")
        let vc = GuanLianKehuVC()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //MARK: - 方法
    func getStringSize(str:NSAttributedString)->CGSize{
        let frameSetterRef = CTFramesetterCreateWithAttributedString(str)
        let cfRange = CFRangeMake(0, 0)
        let maxSize = CGSize(width: fullScreenWidth - 139.5, height: CGFloat.greatestFiniteMagnitude)
        let size = CTFramesetterSuggestFrameSizeWithConstraints(frameSetterRef, cfRange, nil, maxSize, nil)
        return size
    }
    
    //MARK:--查看全部商品
    @objc func showDetailList(){
        print("showDetailList")
        let vc = ShowAlGoodsViewController()
        self.navigationController?.pushViewController(vc, animated: true)

    }
    //MARK:--底部按钮代理
    @objc func bottomButtonClickAction(sender:UIButton){
        print(sender.tag)
        //预售商品价格
        let vc = XiuGaiYuShouJiaViewController()
        self.navigationController?.pushViewController(vc, animated: true)
        //普通商品修改价格
//        let vc = ChangeGoodsPriceVC()
//        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    
    
}
